/*
 * Copyright (C) 2013 Canonical, Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Pawel Stolowski <pawel.stolowski@canonical.com>
 */

#ifndef SELFSERVICEBUNDLESQUERY_H
#define SELFSERVICEBUNDLESQUERY_H

#include <unity/scopes/ScopeBase.h>
#include <unity/scopes/SearchQueryBase.h>
#include <QStringList>
#include <string>
#include <memory>

class SelfServiceBundlesQuery: public unity::scopes::SearchQueryBase
{
public:
    SelfServiceBundlesQuery(unity::scopes::CannedQuery const& query, QStringList const& scopes, QString const& locale);
    
    virtual void run(unity::scopes::SearchReplyProxy const& reply) override;
    virtual void cancelled() override;

private:
    unity::scopes::CannedQuery query_;
    QStringList scopes_;
};

#endif
