/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/*
 * Copyright (C) 2013 Canonical, Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Pawel Stolowski <pawel.stolowski@canonical.com>
 */

#ifndef SELFSERVICEBUNDLESSCOPE_H
#define SELFSERVICEBUNDLESSCOPE_H

#include <unity/scopes/ScopeBase.h>
#include <unity/scopes/SearchQueryBase.h>
#include <unity/scopes/PreviewReply.h>
#include <unity/scopes/PreviewWidget.h>
#include <unity/scopes/VariantBuilder.h>
#include <string>
#include <QString>
#include <QStringList>
#include <QSet>

class QCoreApplication;

class SelfServiceBundlesScope: public unity::scopes::ScopeBase
{
public:
    SelfServiceBundlesScope();
    ~SelfServiceBundlesScope();

    virtual int start(std::string const&, unity::scopes::RegistryProxy const&) override;
    virtual void stop() override {}
    virtual void run() override {}
    virtual unity::scopes::SearchQueryBase::UPtr search(unity::scopes::CannedQuery const& query, unity::scopes::SearchMetadata const&) override;
    virtual unity::scopes::PreviewQueryBase::UPtr preview(unity::scopes::Result const&, unity::scopes::ActionMetadata const&) override;

private:
    void appendIfEnabled(QStringList &scopeToQuery, const QString &scopeId) const;

    //static void disabled_scopes_changed(GObject *obj, GParamSpec *spec, gpointer user_data);
    void updateDisabledScopes();

    QCoreApplication *m_app;
    QString m_locale;
    QSet<QString> m_disabledScopes;
    //gulong m_disabledScopesSig;
};

class SelfServiceBundlesPreview : public unity::scopes::PreviewQueryBase
{
public:
    SelfServiceBundlesPreview(SelfServiceBundlesScope &scope, unity::scopes::Result const& result);
    virtual void cancelled() override;
    virtual void run(unity::scopes::PreviewReplyProxy const& reply) override;

private:
    const SelfServiceBundlesScope &scope;
    const unity::scopes::Result result;
};

#endif
